View Issue Details

IDProjectCategoryView StatusLast Update
0032882PatchesLCLpublic2018-02-06 06:10
ReporterCudaText man Assigned ToOndrej Pokorny  
PrioritynormalSeverityminorReproducibilityN/A
Status resolvedResolutionfixed 
Product Version1.9 (SVN) 
Summary0032882: AutoAdjustLayout, added param AScaleFont
Descriptionthis param allows to not scale font (if set to false).
default is true (scale).
TagsNo tags attached.
Fixed in Revision56962
LazTarget-
Widgetset
Attached Files

Relationships

related to 0033132 closedOndrej Pokorny Lazarus high-dpi: font.size was shrinked when not 0 

Activities

CudaText man

2017-12-26 15:46

reporter  

param.diff (18,548 bytes)   
Index: components/synedit/synedit.pp
===================================================================
--- components/synedit/synedit.pp	(revision 56850)
+++ components/synedit/synedit.pp	(working copy)
@@ -785,7 +785,8 @@
     property TextDrawer: TheTextDrawer read fTextDrawer;
 
     procedure DoAutoAdjustLayout(const AMode: TLayoutAdjustmentPolicy;
-      const AXProportion, AYProportion: Double); override;
+      const AXProportion, AYProportion: Double;
+      AScaleFont: boolean=true); override;
   protected
     procedure CreateHandle; override;
     procedure CreateParams(var Params: TCreateParams); override;
@@ -8232,8 +8233,8 @@
 end;
 
 procedure TCustomSynEdit.DoAutoAdjustLayout(
-  const AMode: TLayoutAdjustmentPolicy; const AXProportion, AYProportion: Double
-  );
+  const AMode: TLayoutAdjustmentPolicy; const AXProportion,
+  AYProportion: Double; AScaleFont: boolean);
 begin
   inherited DoAutoAdjustLayout(AMode, AXProportion, AYProportion);
 
Index: lcl/colorbox.pas
===================================================================
--- lcl/colorbox.pas	(revision 56850)
+++ lcl/colorbox.pas	(working copy)
@@ -70,7 +70,8 @@
     procedure Loaded; override;
     procedure InitializeWnd; override;
     procedure DoAutoAdjustLayout(const AMode: TLayoutAdjustmentPolicy;
-      const AXProportion, AYProportion: Double); override;
+      const AXProportion, AYProportion: Double;
+      AScaleFont: boolean=true); override;
     procedure DoGetColors; virtual;
     procedure CloseUp; override;
     function PickCustomColor: Boolean; virtual;
@@ -190,7 +191,8 @@
     procedure Loaded; override;
     procedure InitializeWnd; override;
     procedure DoAutoAdjustLayout(const AMode: TLayoutAdjustmentPolicy;
-      const AXProportion, AYProportion: Double); override;
+      const AXProportion, AYProportion: Double;
+      AScaleFont: boolean=true); override;
     procedure DoGetColors; virtual;
     procedure DoSelectionChange(User: Boolean); override;
     function PickCustomColor: Boolean; virtual;
@@ -549,8 +551,8 @@
 end;
 
 procedure TCustomColorBox.DoAutoAdjustLayout(
-  const AMode: TLayoutAdjustmentPolicy; const AXProportion, AYProportion: Double
-  );
+  const AMode: TLayoutAdjustmentPolicy; const AXProportion,
+  AYProportion: Double; AScaleFont: boolean);
 begin
   inherited DoAutoAdjustLayout(AMode, AXProportion, AYProportion);
 
@@ -929,8 +931,8 @@
 end;
 
 procedure TCustomColorListBox.DoAutoAdjustLayout(
-  const AMode: TLayoutAdjustmentPolicy; const AXProportion, AYProportion: Double
-  );
+  const AMode: TLayoutAdjustmentPolicy; const AXProportion,
+  AYProportion: Double; AScaleFont: boolean);
 begin
   inherited DoAutoAdjustLayout(AMode, AXProportion, AYProportion);
 
Index: lcl/comctrls.pp
===================================================================
--- lcl/comctrls.pp	(revision 56850)
+++ lcl/comctrls.pp	(working copy)
@@ -160,7 +160,8 @@
     procedure LMDrawItem(var Message: TLMDrawItems); message LM_DRAWITEM;
 
     procedure DoAutoAdjustLayout(const AMode: TLayoutAdjustmentPolicy;
-      const AXProportion, AYProportion: Double); override;
+      const AXProportion, AYProportion: Double;
+      AScaleFont: boolean=true); override;
   public
     constructor Create(TheOwner: TComponent); override;
     destructor Destroy; override;
@@ -1491,7 +1492,8 @@
     procedure DoItemChecked(AItem: TListItem);
     procedure DoSelectItem(AItem: TListItem; ASelected: Boolean); virtual;
     procedure DoAutoAdjustLayout(const AMode: TLayoutAdjustmentPolicy;
-      const AXProportion, AYProportion: Double); override;
+      const AXProportion, AYProportion: Double;
+      AScaleFont: boolean=true); override;
     procedure DoSetBounds(ALeft, ATop, AWidth, AHeight: integer); override;
 
     procedure DoEndEdit(AItem: TListItem; const AValue: String); virtual;
@@ -2265,7 +2267,8 @@
                          Simulate: boolean): Boolean;
     procedure CNDropDownClosed(var Message: TLMessage); message CN_DROPDOWNCLOSED;
     procedure DoAutoAdjustLayout(const AMode: TLayoutAdjustmentPolicy;
-      const AXProportion, AYProportion: Double); override;
+      const AXProportion, AYProportion: Double;
+      AScaleFont: boolean=true); override;
   public
     constructor Create(TheOwner: TComponent); override;
     destructor Destroy; override;
@@ -3442,7 +3445,8 @@
       Stage: TCustomDrawStage; var PaintImages: Boolean): Boolean; virtual;
     function DefaultItemHeightIsStored: Boolean;
     procedure DoAutoAdjustLayout(const AMode: TLayoutAdjustmentPolicy;
-      const AXProportion, AYProportion: Double); override;
+      const AXProportion, AYProportion: Double;
+      AScaleFont: boolean=true); override;
     function ExpandSignSizeIsStored: Boolean;
     function GetDragImages: TDragImageList; override;
     function GetMaxLvl: integer;
@@ -3914,7 +3918,8 @@
     procedure UpdateState;
     class function GetControlClassDefaultSize: TSize; override;
     procedure DoAutoAdjustLayout(const AMode: TLayoutAdjustmentPolicy;
-      const AXProportion, AYProportion: Double); override;
+      const AXProportion, AYProportion: Double;
+      AScaleFont: boolean=true); override;
   public
     property SectionFromOriginalIndex[OriginalIndex: Integer]: THeaderSection read GetSectionFromOriginalIndex;
 
Index: lcl/controls.pp
===================================================================
--- lcl/controls.pp	(revision 56850)
+++ lcl/controls.pp	(working copy)
@@ -1432,7 +1432,8 @@
     class function GetControlClassDefaultSize: TSize; virtual;
     function ColorIsStored: boolean; virtual;
     procedure DoAutoAdjustLayout(const AMode: TLayoutAdjustmentPolicy;
-      const AXProportion, AYProportion: Double); virtual;
+      const AXProportion, AYProportion: Double;
+      AScaleFont: boolean=true); virtual;
     procedure DoFixDesignFontPPI(const AFont: TFont; const ADesignTimePPI: Integer);
     procedure DoScaleFontPPI(const AFont: TFont; const AProportion: Double);
   protected
@@ -1562,7 +1563,8 @@
   public
     // LCL Scaling (High-DPI)
     procedure AutoAdjustLayout(AMode: TLayoutAdjustmentPolicy;
-      const AFromPPI, AToPPI, AOldFormWidth, ANewFormWidth: Integer); virtual;
+      const AFromPPI, AToPPI, AOldFormWidth, ANewFormWidth: Integer;
+      AScaleFont: boolean=true); virtual;
     procedure ShouldAutoAdjust(var AWidth, AHeight: Boolean); virtual;
     procedure FixDesignFontsPPI(const ADesignTimePPI: Integer); virtual;
     procedure ScaleFontsPPI(const AProportion: Double); virtual;
@@ -2246,7 +2248,8 @@
     procedure ScrollBy(DeltaX, DeltaY: Integer); virtual;
     procedure WriteLayoutDebugReport(const Prefix: string); override;
     procedure AutoAdjustLayout(AMode: TLayoutAdjustmentPolicy; const AFromPPI,
-      AToPPI, AOldFormWidth, ANewFormWidth: Integer); override;
+      AToPPI, AOldFormWidth, ANewFormWidth: Integer;
+      AScaleFont: boolean=true); override;
   public
     constructor Create(TheOwner: TComponent);override;
     constructor CreateParented(AParentWindow: HWND);
Index: lcl/forms.pp
===================================================================
--- lcl/forms.pp	(revision 56850)
+++ lcl/forms.pp	(working copy)
@@ -262,6 +262,8 @@
     property OnPaint;
   end;
 
+  { TCustomDesignControl }
+
   TCustomDesignControl = class(TScrollingWinControl)
   private
     FScaled: Boolean;
@@ -273,9 +275,11 @@
     procedure SetScaled(const AScaled: Boolean); virtual;
 
     procedure AutoAdjustLayout(AMode: TLayoutAdjustmentPolicy; const AFromPPI,
-      AToPPI, AOldFormWidth, ANewFormWidth: Integer); override;
+      AToPPI, AOldFormWidth, ANewFormWidth: Integer;
+      AScaleFont: boolean=true); override;
     procedure DoAutoAdjustLayout(const AMode: TLayoutAdjustmentPolicy;
-      const AXProportion, AYProportion: Double); override;
+      const AXProportion, AYProportion: Double;
+      AScaleFont: boolean=true); override;
     procedure Loaded; override;
   public
     constructor Create(TheOwner: TComponent); override;
Index: lcl/grids.pas
===================================================================
--- lcl/grids.pas	(revision 56850)
+++ lcl/grids.pas	(working copy)
@@ -985,7 +985,8 @@
     function  DoMouseWheelLeft(Shift: TShiftState; MousePos: TPoint): Boolean; override;
     function  DoMouseWheelRight(Shift: TShiftState; MousePos: TPoint): Boolean; override;
     procedure DoAutoAdjustLayout(const AMode: TLayoutAdjustmentPolicy;
-      const AXProportion, AYProportion: Double); override;
+      const AXProportion, AYProportion: Double;
+      AScaleFont: boolean=true); override;
     procedure DoOnChangeBounds; override;
     procedure DoOPDeleteColRow(IsColumn: Boolean; index: Integer);
     procedure DoOPExchangeColRow(IsColumn: Boolean; index, WithIndex: Integer);
@@ -5299,7 +5300,7 @@
       end;
 end;
 
-function TCustomGrid.GetDefColWidth: integer;
+function TCustomGrid.GetDefColWidth: Integer;
 begin
   if FDefColWidth<0 then
   begin
@@ -5310,7 +5311,7 @@
     Result := FDefColWidth;
 end;
 
-function TCustomGrid.GetDefRowHeight: integer;
+function TCustomGrid.GetDefRowHeight: Integer;
 begin
   if FDefRowHeight<0 then
   begin
@@ -6966,7 +6967,7 @@
 end;
 
 procedure TCustomGrid.DoAutoAdjustLayout(const AMode: TLayoutAdjustmentPolicy;
-  const AXProportion, AYProportion: Double);
+  const AXProportion, AYProportion: Double; AScaleFont: boolean);
 var
   i: Integer;
   C: TGridColumn;
Index: lcl/include/control.inc
===================================================================
--- lcl/include/control.inc	(revision 56850)
+++ lcl/include/control.inc	(working copy)
@@ -3117,7 +3117,7 @@
 end;
 
 procedure TControl.DoAutoAdjustLayout(const AMode: TLayoutAdjustmentPolicy;
-  const AXProportion, AYProportion: Double);
+  const AXProportion, AYProportion: Double; AScaleFont: boolean=true);
 var
   AAWidth, AAHeight: Boolean;
   NewLeft, NewTop, NewWidth, NewHeight, NewRight, NewBottom, OldWidth, OldHeight,
@@ -3128,7 +3128,7 @@
   begin
     DisableAutoSizing{$IFDEF DebugDisableAutoSizing}('TControl.DoAutoAdjustLayout'){$ENDIF};
     try
-      if not ParentFont or (Parent=nil) then
+      if AScaleFont and not ParentFont or (Parent=nil) then
         ScaleFontsPPI(AYProportion);
 
       // Dimensions
@@ -4148,7 +4148,8 @@
 end;
 
 procedure TControl.AutoAdjustLayout(AMode: TLayoutAdjustmentPolicy;
-  const AFromPPI, AToPPI, AOldFormWidth, ANewFormWidth: Integer);
+  const AFromPPI, AToPPI, AOldFormWidth, ANewFormWidth: Integer;
+  AScaleFont: boolean=true);
 var
   lXProportion, lYProportion: Double;
   lMode: TLayoutAdjustmentPolicy;
@@ -4172,7 +4173,7 @@
   if AFromPPI > 0 then lYProportion := AToPPI / AFromPPI
   else lYProportion := 1.0;
 
-  DoAutoAdjustLayout(lMode, lXProportion, lYProportion);
+  DoAutoAdjustLayout(lMode, lXProportion, lYProportion, AScaleFont);
 end;
 
 // Auto-adjust the layout of controls.
Index: lcl/include/customcombobox.inc
===================================================================
--- lcl/include/customcombobox.inc	(revision 56850)
+++ lcl/include/customcombobox.inc	(working copy)
@@ -85,8 +85,8 @@
 end;
 
 procedure TCustomComboBox.DoAutoAdjustLayout(
-  const AMode: TLayoutAdjustmentPolicy; const AXProportion, AYProportion: Double
-  );
+  const AMode: TLayoutAdjustmentPolicy; const AXProportion,
+  AYProportion: Double; AScaleFont: boolean);
 begin
   inherited;
 
Index: lcl/include/customdesigncontrol.inc
===================================================================
--- lcl/include/customdesigncontrol.inc	(revision 56850)
+++ lcl/include/customdesigncontrol.inc	(working copy)
@@ -23,7 +23,8 @@
 end;
 
 procedure TCustomDesignControl.AutoAdjustLayout(AMode: TLayoutAdjustmentPolicy;
-  const AFromPPI, AToPPI, AOldFormWidth, ANewFormWidth: Integer);
+  const AFromPPI, AToPPI, AOldFormWidth, ANewFormWidth: Integer;
+  AScaleFont: boolean);
 begin
   inherited;
 
@@ -32,8 +33,8 @@
 end;
 
 procedure TCustomDesignControl.DoAutoAdjustLayout(
-  const AMode: TLayoutAdjustmentPolicy; const AXProportion, AYProportion: Double
-  );
+  const AMode: TLayoutAdjustmentPolicy; const AXProportion,
+  AYProportion: Double; AScaleFont: boolean);
 var
   NewWidth, NewHeight: Integer;
 begin
Index: lcl/include/customlistbox.inc
===================================================================
--- lcl/include/customlistbox.inc	(revision 56850)
+++ lcl/include/customlistbox.inc	(working copy)
@@ -314,7 +314,7 @@
   DoSelectionChange(FLockSelectionChange = 0);
 end;
 
-procedure TCustomListBox.WMLButtonUp(var Message: TLMLButtonUp);
+procedure TCustomListBox.WMLButtonUp(Var Message: TLMLButtonUp);
 begin
   // prevent Click to be called twice when using selchange as click
   if ClickOnSelChange and FClickTriggeredBySelectionChange then
@@ -474,8 +474,8 @@
 end;
 
 procedure TCustomListBox.DoAutoAdjustLayout(
-  const AMode: TLayoutAdjustmentPolicy; const AXProportion, AYProportion: Double
-  );
+  const AMode: TLayoutAdjustmentPolicy; const AXProportion,
+  AYProportion: Double; AScaleFont: boolean);
 begin
   inherited;
 
Index: lcl/include/customlistview.inc
===================================================================
--- lcl/include/customlistview.inc	(revision 56850)
+++ lcl/include/customlistview.inc	(working copy)
@@ -612,8 +612,8 @@
 end;
 
 procedure TCustomListView.DoAutoAdjustLayout(
-  const AMode: TLayoutAdjustmentPolicy; const AXProportion, AYProportion: Double
-  );
+  const AMode: TLayoutAdjustmentPolicy; const AXProportion,
+  AYProportion: Double; AScaleFont: boolean);
 var
   i: Integer;
   C: TListColumn;
Index: lcl/include/headercontrol.inc
===================================================================
--- lcl/include/headercontrol.inc	(revision 56850)
+++ lcl/include/headercontrol.inc	(working copy)
@@ -167,7 +167,7 @@
     FOnSectionSeparatorDblClick(Self, Section);
 end;
 
-procedure TCustomHeaderControl.SectionEndDrag();
+procedure TCustomHeaderControl.SectionEndDrag;
 begin
   if Assigned(FOnSectionEndDrag) then
     FOnSectionEndDrag(self);
@@ -417,8 +417,9 @@
     ThemeServices.DrawText(Canvas, Details, Section.Text, ContentRect, AlignmentMap[Section.Alignment] or DT_VCENTER or DT_SINGLELINE, 0);
 end;
 
-procedure TCustomHeaderControl.DoAutoAdjustLayout(const AMode: TLayoutAdjustmentPolicy;
-  const AXProportion, AYProportion: Double);
+procedure TCustomHeaderControl.DoAutoAdjustLayout(
+  const AMode: TLayoutAdjustmentPolicy; const AXProportion,
+  AYProportion: Double; AScaleFont: boolean);
 var
   I: integer;
   Sect: THeaderSection;
Index: lcl/include/promptdialog.inc
===================================================================
--- lcl/include/promptdialog.inc	(revision 56850)
+++ lcl/include/promptdialog.inc	(working copy)
@@ -19,7 +19,8 @@
     function CreateButtons(AVerticalLayout: Boolean; ASpacing: Integer): Integer;
   protected
     procedure DoAutoAdjustLayout(const AMode: TLayoutAdjustmentPolicy;
-      const AXProportion, AYProportion: Double); override;
+      const AXProportion, AYProportion: Double;
+      AScaleFont: boolean=true); override;
     procedure ChangeScale(Multiplier, Divider: Integer); override;
     procedure FontChanged(Sender: TObject); override;
   public
@@ -226,7 +227,7 @@
 
 procedure TPromptDialog.DoAutoAdjustLayout(
   const AMode: TLayoutAdjustmentPolicy; const AXProportion,
-  AYProportion: Double);
+  AYProportion: Double; AScaleFont: boolean);
 begin
   inherited DoAutoAdjustLayout(AMode, AXProportion, AYProportion);
 
Index: lcl/include/statusbar.inc
===================================================================
--- lcl/include/statusbar.inc	(revision 56850)
+++ lcl/include/statusbar.inc	(working copy)
@@ -148,7 +148,7 @@
 end;
 
 procedure TStatusBar.DoAutoAdjustLayout(const AMode: TLayoutAdjustmentPolicy;
-  const AXProportion, AYProportion: Double);
+  const AXProportion, AYProportion: Double; AScaleFont: boolean);
 var
   I: Integer;
 begin
Index: lcl/include/toolbar.inc
===================================================================
--- lcl/include/toolbar.inc	(revision 56850)
+++ lcl/include/toolbar.inc	(working copy)
@@ -355,7 +355,7 @@
 end;
 
 procedure TToolBar.DoAutoAdjustLayout(const AMode: TLayoutAdjustmentPolicy;
-  const AXProportion, AYProportion: Double);
+  const AXProportion, AYProportion: Double; AScaleFont: boolean);
 begin
   inherited;
 
Index: lcl/include/treeview.inc
===================================================================
--- lcl/include/treeview.inc	(revision 56850)
+++ lcl/include/treeview.inc	(working copy)
@@ -3332,8 +3332,8 @@
 end;
 
 procedure TCustomTreeView.DoAutoAdjustLayout(
-  const AMode: TLayoutAdjustmentPolicy; const AXProportion, AYProportion: Double
-  );
+  const AMode: TLayoutAdjustmentPolicy; const AXProportion,
+  AYProportion: Double; AScaleFont: boolean);
 begin
   inherited DoAutoAdjustLayout(AMode, AXProportion, AYProportion);
 
Index: lcl/include/wincontrol.inc
===================================================================
--- lcl/include/wincontrol.inc	(revision 56850)
+++ lcl/include/wincontrol.inc	(working copy)
@@ -3848,7 +3848,8 @@
 end;
 
 procedure TWinControl.AutoAdjustLayout(AMode: TLayoutAdjustmentPolicy;
-  const AFromPPI, AToPPI, AOldFormWidth, ANewFormWidth: Integer);
+  const AFromPPI, AToPPI, AOldFormWidth, ANewFormWidth: Integer;
+  AScaleFont: boolean=true);
 var
   i: Integer;
 begin
Index: lcl/stdctrls.pp
===================================================================
--- lcl/stdctrls.pp	(revision 56850)
+++ lcl/stdctrls.pp	(working copy)
@@ -328,7 +328,8 @@
     procedure CloseUp; virtual;
     procedure AdjustDropDown; virtual;
     procedure DoAutoAdjustLayout(const AMode: TLayoutAdjustmentPolicy;
-      const AXProportion, AYProportion: Double); override;
+      const AXProportion, AYProportion: Double;
+      AScaleFont: boolean=true); override;
 
     function GetItemCount: Integer; //override;
     function GetItemHeight: Integer; virtual;
@@ -561,7 +562,8 @@
     procedure SetStyle(Val: TListBoxStyle); virtual;
     procedure DrawItem(Index: Integer; ARect: TRect; State: TOwnerDrawState); virtual;
     procedure DoAutoAdjustLayout(const AMode: TLayoutAdjustmentPolicy;
-      const AXProportion, AYProportion: Double); override;
+      const AXProportion, AYProportion: Double;
+      AScaleFont: boolean=true); override;
     procedure DoSelectionChange(User: Boolean); virtual;
     procedure SendItemIndex;
     procedure WMGetDlgCode(var Message: TLMNoParams); message LM_GETDLGCODE;
param.diff (18,548 bytes)   

CudaText man

2017-12-26 15:47

reporter   ~0105017

It is set in many files, because many files have this method. it's added in AutoAdjustLayout +DoAutoAdjustLayout.

wp

2017-12-26 16:02

developer   ~0105019

Just out of curiosity: Is there any reason why a font should not be scaled? You know: what looks ok at 100% will look tiny in a scaled 300% environment.

CudaText man

2017-12-26 16:18

reporter   ~0105020

wp,
in Cudatext app, it's needed: Win10, app has Scaled=false, form's Scaled=false. now form has scaled font, and not scaled ctrls.

wp

2017-12-26 17:10

developer   ~0105021

Why don't you turn scaling on?

Ondrej Pokorny

2017-12-27 11:16

developer   ~0105038

> in Cudatext app, it's needed

We don't tend to modify the LCL just because of one application. I am sure you can solve it in a different way.

I don't understand why your fonts are scaled in the first place. LCL scaling uses AutoAdjustLayout as well and font scaling works fine. You should check your code and not modify the LCL.

Ondrej Pokorny

2018-01-05 08:25

developer   ~0105364

Yes, I now see the problem. But it must be solved differently :(

Ondrej Pokorny

2018-01-05 09:11

developer   ~0105366

Alexey, please retest. Now, if you set the AToPPI parameter correctly, your fonts shouldn't be scaled twice.

Issue History

Date Modified Username Field Change
2017-12-26 15:46 CudaText man New Issue
2017-12-26 15:46 CudaText man File Added: param.diff
2017-12-26 15:47 CudaText man Note Added: 0105017
2017-12-26 16:02 wp Note Added: 0105019
2017-12-26 16:18 CudaText man Note Added: 0105020
2017-12-26 17:10 wp Note Added: 0105021
2017-12-27 07:12 Ondrej Pokorny Assigned To => Ondrej Pokorny
2017-12-27 07:12 Ondrej Pokorny Status new => assigned
2017-12-27 11:16 Ondrej Pokorny Note Added: 0105038
2018-01-04 04:54 Ondrej Pokorny LazTarget => -
2018-01-04 04:54 Ondrej Pokorny Status assigned => resolved
2018-01-04 04:54 Ondrej Pokorny Resolution open => won't fix
2018-01-04 05:47 CudaText man Status resolved => closed
2018-01-05 08:25 Ondrej Pokorny Note Added: 0105364
2018-01-05 08:25 Ondrej Pokorny Status closed => assigned
2018-01-05 08:25 Ondrej Pokorny Resolution won't fix => reopened
2018-01-05 09:11 Ondrej Pokorny Fixed in Revision => 56962
2018-01-05 09:11 Ondrej Pokorny Note Added: 0105366
2018-01-05 09:11 Ondrej Pokorny Status assigned => resolved
2018-01-05 09:11 Ondrej Pokorny Resolution reopened => fixed
2018-02-06 06:10 Ondrej Pokorny Relationship added related to 0033132